(* File: operations.mli

   Copyright (C) 2011-2015

     Fabian Pijcke <fabian.pijcke@gmail.com>
     Pierre Hauweele <antegallya@gmail.com>

   This library is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License version 3 or
   later as published by the Free Software Foundation, with the special
   exception on linking described in the file LICENSE.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the file
   LICENSE for more details. *)

type operation =
  | Copy
  | Rectify
  | Dualize
  | Truncate of float
  | Bitruncate
  | Cantellate of float
  | Omnitruncate
  | Snub
  | Snub_right

val copy : Wythoff.polyhedron -> Wythoff.polyhedron
val dualize : Wythoff.polyhedron -> Wythoff.polyhedron
val truncate : ?dist:float -> Wythoff.polyhedron -> Wythoff.polyhedron
val bitruncate : Wythoff.polyhedron -> Wythoff.polyhedron
val cantellate : ?dist:float -> Wythoff.polyhedron -> Wythoff.polyhedron
val omnitruncate : Wythoff.polyhedron -> Wythoff.polyhedron
val snub : Wythoff.polyhedron -> Wythoff.polyhedron
val snub_right : Wythoff.polyhedron -> Wythoff.polyhedron

val apply : operation -> Wythoff.polyhedron -> Wythoff.polyhedron
