(* File: common_basics.ml

   Copyright (C) 2011-2015

     Fabian Pijcke <fabian.pijcke@gmail.com>
     Pierre Hauweele <antegallya@gmail.com>

   This library is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License version 3 or
   later as published by the Free Software Foundation, with the special
   exception on linking described in the file LICENSE.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the file
   LICENSE for more details. *)

open Printf
open OUnit
open Common

let tests = "Common module basic tests" >::: [
  "approx_equals" >:: (fun () ->
    let a = -. 0. and b = 0. in
    "0. and -0. are not equal" @? (a =~ b)
  );

  "pi value" >:: (fun () ->
    "pi is not 3.1415926535" @? (pi =~ 3.1415926535)
  );

  "unicizification" >:: (fun () ->
    let l = [
      (0.6176372375, 0.0225101274, 0.7861409142);
      (0., -0., 1.);
      (0., 0., 1.);
      (0.6176372375, 0., 1.);
      (-0.2893242766, 0.5461446017, 0.7861409142);
      (0.6176372375, 0.0225101274, 0.7861409142);
      (0., 0., 1.);
      (0.6176372375, 0.0225101274, 0.7861409142);
      (0., 0., 1.)] in
    let l' = unicize l in
    assert_equal 4 (List.length l')
  )
]
