(* File: vrml.ml

   Copyright (C) 2011-2015

     Fabian Pijcke <fabian.pijcke@gmail.com>
     Pierre Hauweele <antegallya@gmail.com>

   This library is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License version 3 or
   later as published by the Free Software Foundation, with the special
   exception on linking described in the file LICENSE.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the file
   LICENSE for more details. *)

open Printf
open Wythoff

let () =
  let show = ref Dumper.Faces in
  let number = ref false in
  let arg_edges =
    ("-e", Arg.Unit (fun () -> show := Dumper.Lines),
     "Show edges instead of faces")
  in
  let arg_number =
    ("-n", Arg.Unit (fun () -> number := true),
     "Show vertices numbers")
  in
  let parse s =
    let p = poly_from_string s in
    Dumper.to_vrml ~show:!show ~number:!number p
  in
  Arg.parse [arg_edges; arg_number] parse
    ("Usage: ./vrml \"p q r\" with a bar (e.g. \"3 | 2 5\" or \"3/2 3 2|\")"
     ^ " or spherical coordinates between parentheses, omitting the radius"
     ^ " (e.g. \"p q r (0.4398, 3.087438)\"), the bar or coordinates"
     ^ " determines the starting point into the spherical triangle delimited"
     ^ " by the angles p, q and r.");
